<?php
namespace Teknisa\PED\Modules\Expedicao\Factories;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Pedidosexpedicao\Entities\Precobase;
use Teknisa\Model\Pedidosexpedicao\Entities\Promoprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Opcioprbase;
use Teknisa\Model\Pedidosexpedicao\Entities\Itemprebase;
use Teknisa\Model\Eventos\Entities\Prbaseconvidaore;

class Exp02100RotaEntregaFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection       = $entityManager->getConnection();
        $this->entityManager    = $entityManager;
    }
    
    public function deleteTabelaFilialrota($nrorg,$cdrotatrans){
        try {
         
            $sql = "DELETE FROM FILIALROTA
                    WHERE NRORG = :NRORG AND
                        CDROTATRANS    = :CDROTATRANS";

            $params = array(
                'NRORG'=>$nrorg,
                'CDROTATRANS'=>$cdrotatrans
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteTabelaClienterota($nrorg,$cdrotatrans){
        try {
         
            $sql = "DELETE FROM CLIENROTA
                    WHERE NRORG = :NRORG AND
                        CDROTATRANS    = :CDROTATRANS";

            $params = array(
                'NRORG'=>$nrorg,
                'CDROTATRANS'=>$cdrotatrans
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    public function deleteTabelaMunicipiorota($nrorg,$cdrotatrans){
        try {
         
            $sql = "DELETE FROM MUNICIPIROTA
                    WHERE NRORG = :NRORG AND
                        CDROTATRANS    = :CDROTATRANS";

            $params = array(
                'NRORG'=>$nrorg,
                'CDROTATRANS'=>$cdrotatrans
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
    
    public function deleteTabelaRota($nrorg,$cdrotatrans){
        try {
         
            $sql = "DELETE FROM ROTATRANS
                    WHERE NRORG = :NRORG AND
                        CDROTATRANS    = :CDROTATRANS";

            $params = array(
                'NRORG'=>$nrorg,
                'CDROTATRANS'=>$cdrotatrans
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            
        }catch (\Exception $e) {
            throw $e;
        }
       
    }
    
}