<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

    use Teknisa\PED\Controllers\TeknisaCrud;
    use Doctrine\ORM\EntityManager;
    use Zeedhi\Framework\DataSource\ParameterBag;
    use Teknisa\Libs\Util\Libraries\PHPMailer;
    use Teknisa\PED\Modules\Pedidos\Services\Ped05700importacaoSolicitacaoComprasService;
    use Zeedhi\Framework\DataSource\DataSet;
    use Zeedhi\Framework\DataSource\FilterCriteria;
    use Zeedhi\Framework\DTO\Response\Error;
    use Zeedhi\Framework\DTO\Response;
    use Zeedhi\Framework\DTO\Request\Row;
    use Zeedhi\Framework\DTO;

class Ped05700importacaoSolicitacaoComprasController extends TeknisaCrud {
    protected $entityManager;
    protected $environment;
    protected $Ped05700importacaoSolicitacaoComprasService;
    protected $newCode;
    
    public function __construct($crudService, $parameterBag, $entityManager,  $environment, $Ped05700importacaoSolicitacaoComprasService, $newCode){
        parent::__construct($crudService, $parameterBag);
        $this->entityManager        	= $entityManager;
        $this->environment              = $environment;
        $this->parameterBag             = $parameterBag;
        $this->Ped05700importacaoSolicitacaoComprasService = $Ped05700importacaoSolicitacaoComprasService;
        $this->newCode                  = $newCode;
    }
    
    
    public function importarSolicitacoes(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        $cdfilial = $this->environment->getCdFilial();
        $arrayErro = [];
        $cdsProdFator = array();
        $cdsErroItemSoli = array();    
        $parampedido = $this->selectParmped($cdfilial);
        foreach($rows as $row){
            
            $cdfilsoli = $row['CDFILSOLI'];
            $cdfillan = $row['CDFILLANCA'];
            $nrsolicmp = $row['NRSOLICMP'];


            $validaParamPed = $this->validaParamped($row,$parampedido);
            
            if($validaParamPed == []){
                $stParam = $parampedido['IDTABPRECO'];
                $erro = false;
            }else{
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = $validaParamPed[0]['DSERRO'];
                array_push($arrayErro, $erro);   
                $erro = true;
            }
            if($parampedido['IDTABPRECO'] == 1){
                $row['CDFATORPRECO'] = null;
            }
            
            if($erro != true){
                
                $precoBase = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($parampedido['CDFILIAL'], $parampedido['CDCLIENTE'], $parampedido['CDVENDEDOR'], $parampedido['CDMODPGTO']);
                if($precoBase[0]['CDPRECOBASE'] != NULL){
                    $precoBase = $precoBase[0]['CDPRECOBASE'];
                }else{
                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                    $erro['DSERRO'] = 'Não há preço base parametrizado.';
                    array_push($arrayErro, $erro);
                    $erro = true;
                }
                
                $paramImpPed = $this->selectParamImpPed($cdfilial);
                
                if($paramImpPed['IDIMPSCDTENTR'] == 'N'){
                    $row['DTPEDIDO'] = $row['DTPROGENTR'];
                    $row['TDTPROGENTR'] = 'T';
                    $row['DTPROGENTR'] = null;
                    
                }else{
                    $row['TDTPROGENTR']= null;
                }  
                
                $dtprogentr = $row['DTPROGENTR'];
                $tdtprogentr =  $row['TDTPROGENTR'];
                
                if(empty($paramImpPed)){
                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                    $erro['DSERRO'] = 'Erro na Parametrização de Pedido';
                    array_push($arrayErro, $erro);
                    $erro = true;
                }
                $itemSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaItemSoli($row['NRSOLICMP'], $row['TDTPROGENTR'], $row['CDGRUPO'], $row['CDSUBGRPROD'], $row['TCDSUBGRPROD'], $row['CDFILLANCA'], $row['DTPROGENTR'], $row['CDFILSOLI']);
                
                if($erro != true){
                    
                    if($paramImpPed['IDIMPSCDTENTR'] == 'S'){ 
                        if($row !=null){ 
                            if($paramImpPed['IDUTRELACPRODSC'] == 'S'){ 
                            $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr,$tdtprogentr, $cdfilial);
                                
                                if($itemSoliRelacProdSC != []){
                                    foreach($itemSoliRelacProdSC as $itemRelac){
                                        
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['NMPRODUTO'] = $itemRelac['NMPRODUTO'];
                                        $erro['DSERRO'] = 'Não há relacionamento produto importação.';
                                        
                                        $exist = array_search($itemRelac['NMPRODUTO'], array_column($arrayErro, 'NMPRODUTO'));
                                        if($exist === false){
                                           array_push($arrayErro, $erro);
                                        }
                                    }
                                    $erro = true;
                                }
                            }
                            
                            if(!$erro){
                                if($stParam == 2){
                                    
                                    $ProdFatorDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFatorDtEnt($cdfilsoli, $cdfillan, $nrsolicmp, $dtprogentr, $cdfilial, $row['CDFATORPRECO']);
                                    if($ProdFatorDtEnt != []){
                                        foreach($ProdFatorDtEnt as $prodFator){ 
                                            $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                            $erro['NMPRODUTO'] = $prodFator['NMPRODUTO'];
                                            $erro['DSERRO'] = 'Produto não possue Fator.';
                                            $exist = array_search($prodFator['NMPRODUTO'], array_column($arrayErro, 'NMPRODUTO'));
                                            if($exist === false){
                                               array_push($arrayErro, $erro);
                                            }
                                            
                                        }
                                        $erro = true;
                                    }
                                }else{
                                    
                                    if($precoBase == null){
                                        
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] = "Não possui preço base.";
                                        array_push($arrayErro, $erro);      
                                        
                                        $erro = true;
                                    }
                                    
                                    if(!$erro){
                                        $precoBaseDtEnt = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBaseDtEnt($cdfilial, $nrsolicmp, $cdfillan, $dtprogentr, $cdfilsoli, $precoBase, $parampedido['CDCLIENTE'], $parampedido['CDMODPGTO']);
                                        if($precoBaseDtEnt != []){
                                            foreach($precoBaseDtEnt as $rowPrecoBase){
                                                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                                $erro['NMPRODUTO'] = $rowPrecoBase['NMPRODUTO'];
                                                $erro['DSERRO'] = "O produto não possui preço.";
                                                $exist = array_search($rowPrecoBase['NMPRODUTO'], array_column($arrayErro, 'NMPRODUTO'));
                                                if($exist === false){
                                                   array_push($arrayErro, $erro);
                                                }
                                            }
                                            $erro = true;
                                        }
                                        $result ='PREC_N_CAD';
                                    }
                                }
                                
                                if(!$erro){
                                    try{
                                        $this->Importar($row, $paramImpPed, $parampedido, $itemSoli);
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] =  'Solicitação importada com sucesso';
                                        array_push($arrayErro, $erro);
                                    } catch (\Exception $e) {
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSEERRO'] = 'Erro ao importar a solicitação.';
                                        // $erro['DSERRO'] =  $e->getMessage();
                                        array_push($arrayErro, $erro);
                                    }
                                }
                                
                            }
                        }
                    }else{
                        
                        if($itemSoli == null || empty($itemSoli)){
                            array_push($cdsErroItemSoli, $row);
                        }else{
                            $itemSoliRelacProdSC = $this->Ped05700importacaoSolicitacaoComprasService->buscaitemSoliRelacProdSC($cdfilsoli, $cdfillan, $nrsolicmp, null, $tdtprogentr, $cdfilial);
                            if($itemSoliRelacProdSC != []){
                                foreach($itemSoliRelacProdSC as $itemRelac){
                                        
                                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                    $erro['NMPRODUTO'] = $itemRelac['NMPRODUTO'];
                                    $erro['DSERRO'] = 'Não há relacionamento produto importação.';
                                    
                                    $exist = array_search($itemRelac['NMPRODUTO'], array_column($arrayErro, 'NMPRODUTO'));
                                    if($exist === false){
                                       array_push($arrayErro, $erro);
                                    }
                                }
                                $erro = true;
                                
                            }
                            
                        }
                        if(!$erro){
                            $parampedidoCdFiliSoli = $this->selectParmped($cdfilsoli);
                            
                            if($parampedidoCdFiliSoli != []){
                                if($parampedidoCdFiliSoli['CDCLIENTE'])
                                    $stCliente = $parampedidoCdFiliSoli['CDCLIENTE'];
                                
                                if($parampedidoCdFiliSoli['CDVENDEDOR'])
                                    $stVendedor = $parampedidoCdFiliSoli['CDVENDEDOR'];
                                    
                                if($parampedidoCdFiliSoli['CDMODPGTO'])
                                    $stModPagto = $parampedidoCdFiliSoli['CDMODPGTO'];
                            }
                            if(array_key_exists('CDFATORPRECO', $row)){
                                $fator = $row['CDFATORPRECO'];
                            }else{
                                $fator = null;
                            }

                            $stResultFunc = $this->prodFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator, $stParam, $stCliente, $stVendedor, $stModPagto, $cdsProdFator );

                            if(!empty($stResultFunc)){
                                foreach($stResultFunc as $stResul){
                                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                    $erro['NMPRODUTO'] = $stResul['NMPRODUTO'];
                                    $erro['DSERRO'] = $stResul['DSERRO'];
                                    array_push($arrayErro, $erro);
                                }
                            }else{
                                try{
                                    $importacao = $this->Importar($row, $paramImpPed, $parampedido, $itemSoli);
                                    if($importacao){
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] =  'Solicitação importada com sucesso';
                                        array_push($arrayErro, $erro);
                                    }else{
                                        $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                        $erro['DSERRO'] =  'Solicitação de compra já importada.';
                                        array_push($arrayErro, $erro);
                                    }
                                } catch (\Exception $e) {
                                    $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                                    $erro['DSERRO'] = 'Erro ao importar a solicitação.';
                                    // $erro['DSERRO'] =  $e->getMessage();
                                    array_push($arrayErro, $erro);
                                }
                            }
                        }
                        
                    }
                }
            }

        }
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet("retorno", $arrayErro));

    }
    
    public function selectParmped($cdfilial){
        $arrayErro = [];
        
        try{
            $filter= array(
                        array("columnName" => "CDFILIAL",
                            "operator" => "=",
                            "value" => $cdfilial
                        )
                     );
            
            $dadosParamped = new DTO\Response();
            $filterCriteria = new FilterCriteria('parampedido', $filter);
            $this->crudService->find($dadosParamped, $filterCriteria);
            $parampedido = $dadosParamped->getDataSets();
            
            
            if(count($parampedido[0]->getRows()) == 0){
                array_push($arrayErro, 'Parametrização de pedidos não encontrada.');
                return $arrayErro;
            }else{
                $parampedido = $parampedido[0]->getRows()[0];
                return $parampedido;
            }
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function selectParamImpPed($cdfilial){
        $arrayErro = [];
        
        try{
            $filter = array(
                        array("columnName" => "CDFILIAL",
                          "operator" => "=",
                          "value" => $cdfilial
                        )
                      );
            
            $dadosparamimppedido = new DTO\Response();
            $filterCriteria = new FilterCriteria('paramimppedido', $filter);
            $this->crudService->find($dadosparamimppedido, $filterCriteria);
            
            $paramimppedido = $dadosparamimppedido->getDataSets();
            
            if(isset($paramimppedido[0])){
                $paramimppedido = $paramimppedido[0]->getRows()[0];  
                return $paramimppedido;
            }else{
                return [];
            }
           
            
        }catch(\Exception $e){
            throw $e;
        }
        
    }
    
    public function validaParamped($row, $parampedido){
    
            $arrayErro = [];

            //Validações da parampedido
            if ($parampedido == null){
                $stParam = 1;
            }else{
                $stParam = $parampedido['IDTABPRECO'];
            }
                
            if ($parampedido['IDOBRTPOPPED'] == 'S' && $parampedido['CDTIPOOPER'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Tipo de operação padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDCLIENTE'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Cliente padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDVENDEDOR'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Vendedor padrão não cadastrado';
                array_push($arrayErro, $erro);
            }
            
            if ($parampedido['CDMODPGTO'] == null){
                $erro['NRSOLICITA'] = $row['NRSOLICMP'];
                $erro['DSERRO'] = 'Modalidade de pagamento padrão não cadastrado';
                array_push($arrayErro, $erro);
            }   
            
            return $arrayErro;
    }
    
    public function prodFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator, $stParam, $stCliente, $stVendedor, $stModPagto, $cdsProdFator){

       $cdsProdFator = array();

        if($stParam == 2){
            $prodFator = $this->Ped05700importacaoSolicitacaoComprasService->buscaProdFator($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $fator);
            if($prodFator != null){
                foreach($prodFator as $rowProdFator){
                    
                    $erro['NRSOLICITA'] = $nrsolicmp;
                    $erro['NMPRODUTO'] = $rowProdFator['NMPRODUTO'];
                    $erro['DSERRO'] = 'Produto sem fator de preço';
                    array_push($cdsProdFator, $erro);                                
                }
            }
        }else{
            $stResult = $this->Ped05700importacaoSolicitacaoComprasService->buscaPrecoBase($cdfilial, $stCliente, $stVendedor, $stModPagto);

            if(!empty($stResult) && $stResult[0]['CDPRECOBASE'] != null && $stResult[0]['CDPRECOBASE'] != 0){

                $selectPrecoBase = $this->Ped05700importacaoSolicitacaoComprasService->selectPrecoBase($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult[0]['CDPRECOBASE']);

                if(!empty($selectPrecoBase)){

                    foreach($selectPrecoBase as $rowPrecoBase){
                        $erro['NRSOLICITA'] = $nrsolicmp;
                        $erro['NMPRODUTO'] = $rowPrecoBase['NMPRODUTO'];
                        $erro['DSERRO'] = 'Produto sem preço base';
                        array_push($cdsProdFator, $erro); 
                    }
                }else{
                    $selectDataEndPed = $this->Ped05700importacaoSolicitacaoComprasService->selectDataEndPed($cdfilsoli, $cdfillan, $nrsolicmp);
                    
                    $selectValidaPreco = $this->Ped05700importacaoSolicitacaoComprasService->selectValidaPreco($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult[0]['CDPRECOBASE'], $selectDataEndPed[0]['DTENTREGA']);

                    if(!empty($selectValidaPreco)){
                        foreach($selectValidaPreco as $rowValidaPreco){
                            $erro['NRSOLICITA'] = $nrsolicmp;
                            $erro['NMPRODUTO'] = $rowValidaPreco['NMPRODUTO'];
                            $erro['DSERRO'] = 'Produto sem preço base';
                            array_push($cdsProdFator, $erro); 
                        }
                    }else{
                        $selectVerificaPrecoZerado = $this->Ped05700importacaoSolicitacaoComprasService->selectValidaPrecoZerado($cdfilial, $cdfilsoli, $cdfillan, $nrsolicmp, $stResult[0]['CDPRECOBASE'], $selectDataEndPed[0]['DTENTREGA']);

                        if(!empty($selectVerificaPrecoZerad0)){
                            foreach($selectVerificaPrecoZerad0 as $rowPrecoZerado){
                                $erro['NRSOLICITA'] = $nrsolicmp;
                                $erro['NMPRODUTO'] = $rowPrecoZerado['NMPRODUTO'];
                                $erro['DSERRO'] = 'Produto com preço zerado';
                                array_push($cdsProdFator, $erro); 
                            }
                        }
                    }
                }

            }
        }
        
        
        return $cdsProdFator;
        
    }
    
    public function Importar($row, $paramImpPed, $parampedido, $itemSoli){
        //$this->entityManager->getConnection()->beginTransaction();
        try {
            
            $fator = $this->Ped05700importacaoSolicitacaoComprasService->buscaFator('', 'T');
            $operador = $this->environment->getCdOperador();
            $cdfilial = $this->environment->getCdFilial();
            $cdgrupprod = $this->Ped05700importacaoSolicitacaoComprasService->selectFilial($cdfilial);

            $retorno = $this->Ped05700importacaoSolicitacaoComprasService->selectExisteSoliCmpPed($row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP'], $row['DTPROGENTR']);
            $importacao = false;
            $dataPedidoSoli = $this->Ped05700importacaoSolicitacaoComprasService->buscaDataPedidoSoli($row['NRSOLICMP'], $row['CDFILSOLI'], $row['CDFILLANCA']);
            if(!$retorno){
                
                if($paramImpPed['IDIMPSCDTENTR'] == 'S'){
                    $prxPedido = $this->newCode->getCodeByTableName('PEDIDO'.$cdfilial, $this->environment->getNrOrgTrab());
                    $retornoGrava_Pedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaPedido($cdfilial, $prxPedido, $operador, $row['DTPROGENTR'], $row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP']);
                    
                    if($retornoGrava_Pedido['P_CDMENSERRO'] == 'OK'){
                        
                        if(!empty($itemSoli)){
                            foreach($itemSoli as $RowItemSoli){
                                $retorno_Grava_ItemPedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaItempedido($cdfilial, $prxPedido, $row['CDFATORPRECO'], $RowItemSoli['CDPRODUTO'], $RowItemSoli['QTSOLIPROD'], $RowItemSoli['DTPROGENTR'], $row['DTPROGENTR']);
                                
                            }
                        }

                        if($parampedido['IDUTRESELOTE'] == 'S'){
                            $this->Ped05700importacaoSolicitacaoComprasService->geraReserva($cdfilial, $prxPedido);
                        }
                        
                        if($parampedido['IDEXIBIMPITPED'] == 'S'){
                            $totalImpost= $this->Ped05700importacaoSolicitacaoComprasService->selectCalcTotImpos($cdfilial, $prxPedido);
                            if($totalImpost != []){
                                foreach($totalImpost as $RowTotalImpost){
                                    $ConsImposPedTot = $this->Ped05700importacaoSolicitacaoComprasService->selectConsImposPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO']);
                                
                                    if($ConsImposPedTot != []){
                                        $this->Ped05700importacaoSolicitacaoComprasService->insertItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                    }else{
                                        $this->Ped05700importacaoSolicitacaoComprasService->updateItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                    }
                                }
    
                            }
                        }
                        
                    }
                    
                }else{
                    if(!empty($itemSoli)){
                        $dtPedido = 0;
                        foreach($dataPedidoSoli as $data){
                            if($dtPedido != $data['DTPROGENTR']){
                                $prxPedido = $this->newCode->getCodeByTableName('PEDIDO'.$cdfilial, $this->environment->getNrOrgTrab());
                                $retorno_Grava_Pedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaPedido($cdfilial, $prxPedido, $operador, $data['DTPROGENTR'], $row['CDFILLANCA'], $row['CDFILSOLI'], $row['NRSOLICMP']);
                                if($retorno_Grava_Pedido['P_CDMENSERRO'] =='OK'){
                                    $itemSoliPorData = $this->Ped05700importacaoSolicitacaoComprasService->bustaItemSoliPorData($row['NRSOLICMP'],  $row['CDFILSOLI'], $row['CDFILLANCA'], $data['DTPROGENTR']);
                                    foreach($itemSoliPorData as $RowItemSoli){
                                        $retorno_Grava_ItemPedido = $this->Ped05700importacaoSolicitacaoComprasService->gravaItempedido($cdfilial, $prxPedido, $row['CDFATORPRECO'], $RowItemSoli['CDPRODUTO'], $RowItemSoli['QTSOLIPROD'], $RowItemSoli['DTPROGENTR'], $RowItemSoli['DTPROGENTR']);
                                
                                        
                                    }

                                }
                            }
                             if($parampedido['IDUTRESELOTE'] == 'S'){
                                $this->Ped05700importacaoSolicitacaoComprasService->geraReserva($cdfilial, $prxPedido);
                            }
                                
                            if($parampedido['IDEXIBIMPITPED'] == 'S'){
                                $totalImpost= $this->Ped05700importacaoSolicitacaoComprasService->selectCalcTotImpos($cdfilial, $prxPedido);
                                if($totalImpost != []){
                                    forEach($totalImpost as $RowTotalImpost){
                                        $ConsImposPedTot = $this->Ped05700importacaoSolicitacaoComprasService->selectConsImposPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO']);
                                    
                                        if($ConsImposPedTot != []){
                                            $this->Ped05700importacaoSolicitacaoComprasService->insertItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                        }else{
                                            $this->Ped05700importacaoSolicitacaoComprasService->updateItemPedTot($RowTotalImpost['CDFILIAL'], $RowTotalImpost['NRPEDIDO'], $RowTotalImpost['CDIMPOSTO'], $RowTotalImpost['VRIMPOSTOTAL'], $RowTotalImpost['VRBASETOTAL']);
                                        }
                                    }
        
                                }
                            }

                        }
                        
                    }

                }
               $importacao = true; 
            }
            return $importacao;
            //$this->entityManager->commit();

        } catch (\Exception $e) {
            //$this->entityManager->rollback();
            throw $e;
        }

    }
};