<?php
namespace Teknisa\PED\Modules\Pedidos\Services;

use Teknisa\PED\Modules\Pedidos\Factories\ped00100PedidosFactory;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO;

class ped00100PedidosService {

    protected $factory;

	public function __construct($crudService, $factory){
	    $this->crudService = $crudService;
	    $this->ped00100PedidosFactory = $factory;
	}

    public function insertVendedorPedAux($pedido) {
        
        $params = array('P_CDFILIAL' => $pedido['CDFILIAL'],
                        'P_NRPEDIDO' => $pedido['NRPEDIDO'],
                        'P_CDVENDEDOR' => $pedido['CDVENDEDOR']);
                            
       $this->ped00100PedidosFactory->insertVendedorPedAux($params);
        
    } 
    
    public function deleteAllVendPedAux($pedido) {
        
        $params = array('P_CDFILIAL' => $pedido['CDFILIAL'],
                        'P_NRPEDIDO' => $pedido['NRPEDIDO']);
        
        return $this->ped00100PedidosFactory->deleteAllVendPedAux($params);
        
    }
    
    public function deleteVendedorPedAux($pedido) {
        
        $params = array('P_CDFILIAL' => $pedido['CDFILIAL'],
                        'P_NRPEDIDO' => $pedido['NRPEDIDO'],
                        'P_CDVENDEDOR' => $pedido['CDVENDEDOR']);
                            
       $this->ped00100PedidosFactory->deleteVendedorPedAux($params);
        
    }

    public function getComissaoVend($pedido, $item, $request, $response) {
        try {
            $this->ped00100PedidosFactory->getComissaoVend($pedido, $item, $request, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getImpostoItem($pedido, $item, $request, $response, $idmobile = 'N') {
        try {
            $this->ped00100PedidosFactory->getImpostoItem($pedido, $item, $request, $response, $idmobile);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getTotalImposto($filial, $nrpedido, $request, $response) {
        try {
            $this->ped00100PedidosFactory->getTotalImposto($filial, $nrpedido, $request, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function returnImposto($filial, $nrpedido, $nrorg) {
        try {
            return $this->ped00100PedidosFactory->returnImposto($filial, $nrpedido, $nrorg);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getValoresPedido($cdfilial, $nrpedido) {
        try {
            return $this->ped00100PedidosFactory->getValoresPedido($cdfilial, $nrpedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getMaxNrdadoadicped($cdfilial, $nrpedido) {
        try {
            return $this->ped00100PedidosFactory->getMaxNrdadoadicped($cdfilial, $nrpedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function insertHist($historico) {
        $this->ped00100PedidosFactory->insertHist($historico);
    }
    
    public function insereItemtrab($item, $response) {
        try {
            $this->ped00100PedidosFactory->insereItemtrab($item, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getImpitempedidotrab($pedido) {
        try {
            return $this->ped00100PedidosFactory->getImpitempedidotrab($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteItemtrab($item, $response) {
        try {
            $this->ped00100PedidosFactory->deleteItemtrab($item, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteImpitempedidotrab($pedido, $response) {
        try {
            $this->ped00100PedidosFactory->deleteImpitempedidotrab($pedido, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function saveEncargotrab($encargo) {
        try {
            $this->ped00100PedidosFactory->saveEncargotrab($encargo);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function deleteEncargotrab($pedido) {
        try {
            $this->ped00100PedidosFactory->deleteEncargotrab($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getImpostosped($pedido) {
        try {
            return $this->ped00100PedidosFactory->getImpostosped($pedido);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function saveImpostototped($imp) {
        try {
            return $this->ped00100PedidosFactory->saveImpostototped($imp);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function geraReserva($item, $response) {
        try {
            return $this->ped00100PedidosFactory->geraReserva($item, $response);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getConditionsPedido() {
        /*
            "E": "enviado",     -> Exclusivo do Mobile
            "N": "não Enviado", -> Exclusivo do Mobile
            "1": "pendente",
            "2": "emAndamento",
            "3": "liquidado",
            "4": "cancelado",
            "5": "liqManual",
            "6": "parcAtendido"
        */
        $conditions = array(
            '1' => array(
                'STATUS_CONFIRMAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '2' => array(
                'STATUS_EXC_APROVACAO',
                'STATUS_EXC_CONFIRMACAO',
                'STATUS_APROVAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '3' => array(),
            '4'=> array(
                'STATUS_EXL_CANCELAR'
            ),
            '5' => array(
                'STATUS_EXC_LIQMANUALMNTPED'
            ),
            '6' => array(
                'STATUS_LIQMANUALMNTPED'
            ),
            '7' => array(
                'STATUS_EXC_APROVACAO',
                'STATUS_EXC_CONFIRMACAO',
                'STATUS_APROVAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '8' => array(
                'STATUS_EXC_APROVACAO',
                'STATUS_EXC_CONFIRMACAO',
                'STATUS_APROVAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            )
        );
            
        return $conditions;
    }
    
    public function getConditionsItens() {
        /*
            "D": "emDigitacao", -> Exclusivo do Mobile
            "1": "pendente",
            "2": "confirmado",
            "3": "aprovado",
            "4": "liquidado",
            "5": "cancelado",
            "6": "liqManual",
            "7": "parcAtendido"
        */
        $conditions = array(
            '1' => array(
                'STATUS_CONFIRMAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '2' => array(
                'STATUS_LIQMANUALMNTPED',
                'STATUS_EXC_CONFIRMACAO',
                'STATUS_APROVAR',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '3' => array(
                'STATUS_EXC_APROVACAO',
                'STATUS_LIQMANUALMNTPED',
                'STATUS_CANCELAR',
                'UPDATE_PED'
            ),
            '4'=> array(),
            '5' => array(
                'STATUS_EXL_CANCELAR'
            ),
            '6' => array(
                'STATUS_EXC_LIQMANUALMNTPED'
            ),
            '7' => array(
                'UPDATE_PED',
                'STATUS_LIQMANUALMNTPED'
            )
        ); 
        return $conditions;
    }
    
    public function defineFilterPedido($row) {
        
        if (isset($row[0])) {
            $row = $row[0];
        }
        
        $filter = array(
            array(
                "value" => $row['NRPEDIDO'],
                "operator" => "=",
                "columnName" => "NRPEDIDO"
            ),
            array(
                "value" => $row['CDFILIAL'],
                "operator" => "=",
                "columnName" => "CDFILIAL"
            )
        );
        return $filter;
    }
    
    public function defineFilterPedidos($rows) {
        
        // Armazena na variavel pedidos os numeros dos pedidos selecionados
        foreach ($rows as $pedido) {
            $pedidos[] = $pedido['NRPEDIDO'];
        }
        
        $cdfilial = $rows[0]['CDFILIAL'];
        
        $filter = array(
            array(
                "columnName" => "NRPEDIDO",
                "operator" => "IN",
                "value" => $pedidos
            ),
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $cdfilial
            )
        );
        return $filter;
    }
    
    public function changeStatusItemPed($itensPed) {
        
        $histItemPed = array();
        
        foreach ($itensPed as $itens) {
            $this->validaItens(null, $itens);
        }
        try {

            foreach ($itensPed as $key => &$row) {
                // Monta o array que sera salvo na tabela de itens do pedido
                $histItemPed[$key]['CDFILIAL']  = $row['CDFILIAL'];
                $histItemPed[$key]['NRPEDIDO']  = $row['NRPEDIDO'];
                $histItemPed[$key]['NRITEMPED'] = $row['NRITEMPED'];
                $histItemPed[$key]['DTHRHIST']  = $row['DTHORA']; // data e hora de hoje;
                $histItemPed[$key]['IDSITANTHIST'] = $row['IDSITITEMPED'];
                $histItemPed[$key]['IDSITATUHIST'] = $row['NOVOSTATUS'];
                $histItemPed[$key]['NRORG'] = $row['NRORG'];
                $histItemPed[$key]['__is_new'] = true; 
                // Altera os status dos itens
                $row['IDSITITEMPED'] = $row['NOVOSTATUS'];
            }

            $this->crudService->save('itempedido', $itensPed);
            
            foreach ($histItemPed as $hist) {
                $this->insertHist($hist);
            }
            
            $filter = $this->defineFilterPedido($itensPed[0]);
           
            
            $name = 'pedido';
            
            $pedidos = $this->getRows($name, $this->getDataSets($name, $filter));
            
            $name = 'itempedido';
            
            $itens =  $this->getRows($name, $this->getDataSets($name, $filter));
            $qtdItensPed= 0;
            
            foreach($itens as $item){
                $qtdItensPed++;
            }

            $intAprovado = 0;
            $intPendente = 0;
            $intConfirmado = 0;
            $intLiquidado = 0;
            $intCancelado = 0;
            $intLiquidadoManual = 0;
            $intParcialmente = 0;
    
            // Armazena no array os status dos itens do pedido
            foreach ($itens as $key => $item) {
                if ($item['IDSITITEMPED'] == '1') {
                    $intPendente++;
                }
                if ($item['IDSITITEMPED'] == '2') {
                    $intConfirmado++;
                }
                if ($item['IDSITITEMPED'] == '3') {
                    $intAprovado++;
                }
                if ($item['IDSITITEMPED'] == '4') {
                    $intLiquidado++;
                }
                if ($item['IDSITITEMPED'] == '5') {
                    $intCancelado++;
                }
                if ($item['IDSITITEMPED'] == '6') {
                    $intLiquidadoManual++;
                }
                if ($item['IDSITITEMPED'] == '7') {
                    $intParcialmente++;
                }
            }
            
            // Muda o status do Pedido dependendo do status dos itens do mesmo
            if ($intCancelado > 0) {
                // CANCELADO
                $pedidos[0]['IDSITPEDIDO'] = '4';
            }
            if ($intPendente > 0) {
                // PENDENTE
                $pedidos[0]['IDSITPEDIDO'] = '1';
            }
            if (($intAprovado > 0)||($intConfirmado > 0) && ($intAprovado + $intConfirmado) == $qtdItensPed) {
                // EM ANDAMENTO
                $pedidos[0]['IDSITPEDIDO'] = '2';
            }
            if ($intLiquidado > 0) {
                if (($intPendente > 0)||( $intAprovado > 0)||( $intConfirmado > 0)) {
                    // PARCIALMENTE
                    $pedidos[0]['IDSITPEDIDO'] = '6';
                } else {
                    // LIQUIDADO
                    $pedidos[0]['IDSITPEDIDO'] = '3';
                }
            }
            if ($intLiquidadoManual > 0) {
                if (($intPendente > 0)||($intAprovado > 0)||($intConfirmado > 0)) {
                    // PARCIALMENTE
                    $pedidos[0]['IDSITPEDIDO'] = '6';
                } else {
                    // LIQUIDADO MANUAL
                    $pedidos[0]['IDSITPEDIDO'] = '5';
                }
            }
            if ($intParcialmente > 0) {
                // PARCIALMENTE
                $pedidos[0]['IDSITPEDIDO'] = '6';
            }
            
            $this->crudService->save('pedido', $pedidos);
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    
    
    public function changeStatusPed($rows) {
        
        // print_r(PHP_EOL);
        // print_r("params function changeStatusPed(rows) -> rows:");
        // print_r(PHP_EOL);
        // print_r(gettype($rows));
        // print_r(PHP_EOL);
        // print_r($rows);
        // print_r(PHP_EOL);

        // rows pode ser apenas uma única row OU pode ser mais de uma row
        
        
        if (isset($rows['1'])) {
            
            foreach($rows as $row) {
                $this->validaPedido($row);
            }
            
            $filterPedidos = $this->defineFilterPedidos($rows);
            $rows = $rows[0];
        } else {
            
            if (isset($rows['0'])) {
                $rows = $rows[0];
            }
            $this->validaPedido($rows);
            $filterPedidos = $this->defineFilterPedido($rows);
        }
        
        
        $name = 'itempedido';
        
        //Busca os itens dos pedidos selecionados
        $itens = $this->getRows($name, $this->getDataSets($name, $filterPedidos));
        $collectionItensPed = array();
        // Coloca os valores a serem setados em cada item do pedido
        // (são os mesmos independente de qual pedido é por isso não faz diferença qual pegar,  $rows[0]['DTHORA'])
        
        foreach ($itens as &$item) {
            $item['DTHORA'] = $rows['DTHORA'];
            if ($rows['NOVOSTATUS'] == '8') {
                $status = '3';
            } else if ($rows['NOVOSTATUS'] == '9'){
                $status = '5';
            } else if ($rows['NOVOSTATUS'] == '10'){
                    $status = '6';
            } else {
                $status = $rows['NOVOSTATUS'];
            }

            $item['CALLED_BY'] = $rows['CALLED_BY'];
            $item['NOVOSTATUS'] = $status;
            
            if (isset($collectionItensPed[$item['NRPEDIDO']])) {
                array_push($collectionItensPed[$item['NRPEDIDO']], $item);
            } else {
                $collectionItensPed[$item['NRPEDIDO']] = array();
                array_push($collectionItensPed[$item['NRPEDIDO']], $item);
            }
        }
        foreach($collectionItensPed as $itensPed) {
            $this->changeStatusItemPed($itensPed);
        }
        
    }
    
    public function validaPedido($row) {
        try {
            $filter = $this->defineFilterPedido($row);
            $name = 'pedido';
            $rows = $this->getRows($name, $this->getDataSets($name, $filter));        
            $pedido = $rows[0];
            $conditions = $this->getConditionsPedido();
            $statusPed = $pedido['IDSITPEDIDO'];
            $actionsPed = $conditions[$pedido['IDSITPEDIDO']];
            if ($statusPed == '2' or $statusPed == '6' ) {
                
                $isValid = $this->validaItens($pedido, $row);
            } else {
                $isValid = false;
                foreach ($actionsPed as $key => $action) {
                    if ($row['CALLED_BY'] == $action) {
                        $isValid = true;
                    } 
                }
            }
            if (!$isValid) {
                throw new \Exception("Operação Bloqueada, favor atualizar a tela.");
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function validaItens($pedido, $row) {
        
        try {
            if($pedido == null) {
                $filter = $this->defineFilterPedido($row);
                $name = 'pedido';
                $rows = $this->getRows($name, $this->getDataSets($name, $filter));
                $pedido = $rows[0];
            }
            
            $filter= $this->defineFilterPedido($pedido);
            $name = 'itempedido';
            $itens = $this->getRows($name, $this->getDataSets($name, $filter));
            $conditions = $this->getConditionsItens();
            
            $statusPed = $pedido['IDSITPEDIDO'];
            $statusItem = array();
            $actionsItens = array();
            $actions = array();
            foreach ($itens as $key => $item) {
               
                array_push($statusItem, $item['IDSITITEMPED']);
            }
            foreach ($statusItem as $status) {
                
                array_push($actionsItens, $conditions[$status]);
            }
            foreach($actionsItens as $actionsItem) {
                
                foreach($actionsItem as $action) {
                    
                    array_push($actions, $action);
                }
            }
            $actions = array_unique($actions);
            $isValid = false;
            
            foreach ($actions as $key => $action) {
                if ((isset($row['CALLED_BY']) && $row['CALLED_BY'] == $action)) {
                    $isValid = true;
                }
            }
            if (!$isValid) {
                throw new \Exception("Operação Bloqueada, favor atualizar a tela.");
            }
            return $isValid;
            
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getDataSets($name, $filter) {
        
        $response = new DTO\Response();
        $filterCriteria = new FilterCriteria($name, $filter);
        $this->crudService->find($response, $filterCriteria);
        $dataSets = $response->getDataSets();
        
        return $dataSets;
    }
    
    public function getRows($name, $dataSets) {
        $rows = array();
        
        foreach ($dataSets as $key => $data) {
            if ($data->getDataSourceName() == $name) {
                $rows = $dataSets[$key]->getRows();
            }
        }
        return $rows;
    }
    
    public function consultaIdPendFin($pedido) {
        
        $params = array(
            'P_CDFILIAL' => $pedido['CDFILIAL'],
            'P_CDCLIENTE' => $pedido['CDCLIENTE']
        );
        try {
            return $this->ped00100PedidosFactory->consultaIdPendFin($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaModPgto($pedido) {
        
        $filter = array(
            
               array(
                    "columnName" => "CDMODPGTO",
                    "operator" => "=",
                    "value" => $pedido["CDMODPGTO"]
                )
            
            );
        
        $name = 'modpgto';    
        
        $modpgto = $this->getRows($name, $this->getDataSets($name, $filter))[0];
        
        return $modpgto;
        
    }
    
    public function consultaPendenciasPedido($pedido) {
        try {
            $params = array(
                'P_CDCLIENTE' => $pedido['CDCLIENTE'],
                'P_CDFILIAL' => $pedido['CDFILIAL']
            );
            
            $result = $this->ped00100PedidosFactory->consultaPendencia($params);
            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaPendencia(array $pedidos) {
        
        $result = array();
        $resultRows = array();
        try {
            
            foreach($pedidos as $pedido) {
                $params = array(
                    'P_CDCLIENTE' => $pedido['CDCLIENTE'],
                    'P_CDFILIAL' => $pedido['CDFILIAL']
                );
                $result[]  = $this->ped00100PedidosFactory->consultaPendencia($params);
            }
            foreach($result as $pedidos) {
                foreach($pedidos as $pendencia) {
                    $resultRows[] = $pendencia;
                }
            }
            return $resultRows;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function consultaIdPendFinGroup($pedidos) {
        
        $p_cdclientes = array();
        $p_cdfiliais = array();
        
        foreach($pedidos as $pedido) {
            $p_cdclientes[] = $pedido['CDCLIENTE'];
            $p_cdfiliais[] =  $pedido['CDFILIAL'];
        }
        
        $params = array(
            'P_CDFILIAL' => $pedidos['CDFILIAL'],
            'P_CDCLIENTE' => $pedidos['CDCLIENTE']
        );
        try {
            return $this->ped00100PedidosFactory->consultaIdPendFin($params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function defineMensagemPedido($pedido, $status) {
        $mensagem = array(
            'CDFILIAL' => $pedido['CDFILIAL'],
            'NRPEDIDO' => $pedido['NRPEDIDO'],
            'MENSAGEM' => $status,
            'CDCLIENTE' => $pedido['CDCLIENTE'],
            'NRLANCTONF' => "",
            'DTATUAVENREC' => "",
            'VRATUAREC' => "",
            "NRNOTAFISC" => ""
        );
        
        return $mensagem; 
    }
    
    public function mesclaPedidoPendencia($pedido,$resultados) {
        
        $pendencias = $this->consultaPendenciasPedido($pedido);
        if (!empty($pendencias[1])) {
            foreach($pendencias as &$pendencia) {
                $pendencia['NRPEDIDO'] = $pedido['NRPEDIDO'];
                $pendencia['MENSAGEM'] = $pedido['MENSAGEM'];
                $resultados[] = $pendencia;
            }
        } else {
            $pendencias = $pendencias[0];
            $pendencias['NRPEDIDO'] = $pedido['NRPEDIDO'];
            $pendencias['MENSAGEM'] = $pedido['MENSAGEM'];
            $resultados[] = $pendencias;
        }
        return $resultados;
    }
    
    public function situacaoItens($itens, $pedido) {

        if (empty($pedido['CDMODPGTO'])){
            $pedido['CDMODPGTO'] = $this->getModpgtoPed($pedido['NRPEDIDO'], $pedido['CDFILIAL'])[0]['CDMODPGTO'];
        }
        
        $modpgto = $this->consultaModPgto($pedido);
        $parampedido = $this->consultaParamPedido($pedido);
        if (empty($modpgto)) {
            
            $itens = $this->processaItemSituacao($itens, $parampedido['IDLANCPED']);
        } else {
            if (strlen($modpgto['IDLANCPEDMOD']) > 0) {
                $itens = $this->processaItemSituacao($itens, $modpgto['IDLANCPEDMOD']);
            } else {
                $itens = $this->processaItemSituacao($itens, $parampedido['IDLANCPED']);
            }
        }
        return $itens;
        
    }
    
    public function processaItemSituacao($itens, $valorCompara) {
        
        foreach($itens as &$item) {
            if ($item['__is_new']) {
                switch($valorCompara) {
                    
                    case '1':
                        $item['IDSITITEMPED'] = '1';
                        break;
                        
                    case '2':
                        $item['IDSITITEMPED'] = '2';
                        break;
                        
                    case '3':
                        $item['IDSITITEMPED'] = '3';
                        break;
                    
                    default:
                        $item['IDSITITEMPED'] = '1';
                        break;
                }
            }
        }
        return $itens;
    }
    
    public function consultaParamPedido($param) {
        
        $filter = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value" => $param["CDFILIAL"]
            )
        );
        
        $name = 'parampedido';
        $parampedido = $this->getRows( $name, $this->getDataSets($name, $filter))[0];
        
        return $parampedido;
    }
    
    public function selectVendPedAux($pedido) {
        $params = array(
            "P_NRPEDIDO" => $pedido["NRPEDIDO"],
            "P_CDFILIAL" => $pedido["CDFILIAL"]
        );
        return $this->ped00100PedidosFactory->selectVendPedAux($params);
    }
    
    public function getModpgtoPed($pedido, $filial) {
        $params = array('P_CDFILIAL' => $filial,
                        'P_NRPEDIDO' => $pedido);
        return $this->ped00100PedidosFactory->getModpgtoPed($params);
    }
    
    public function getDataEntrega($filial, $dtbase) {
        return $this->ped00100PedidosFactory->getDataEntrega($filial, $dtbase);
    }
    
    public function getRotaEnt($idorig, $filialdest, $cdcliente) {
        return $this->ped00100PedidosFactory->getRotaEnt($idorig, $filialdest, $cdcliente);
    }

    public function tabelaItemPedido($pedido){
        return $this->ped00100PedidosFactory->tabelaItemPedido($pedido);
    }
    
    public function endEntregaPed($pedido){
        return $this->ped00100PedidosFactory->endEntregaPed($pedido);
    }
    
    public function getSmtp($pedido){
        return $this->ped00100PedidosFactory->getSmtp($pedido);
    }

    public function deletePedido($params){
        $itempedido = $this->ped00100PedidosFactory->deleteITEMPEDIDO($params);

        $pedido = $this->ped00100PedidosFactory->deletePEDIDO($params);
    }
    
    public function verificaProdutoContEst($cdfilial, $cdproduto){
        return $this->ped00100PedidosFactory->verificaProdutoContEst($cdfilial, $cdproduto);
    }
    
    public function getQtDispQtPed($cdfilial, $cdproduto){
        return $this->ped00100PedidosFactory->getQtDispQtPed($cdfilial, $cdproduto);
    }
    
    public function qtdeDisponivel($cdfilial, $cdproduto, $idctrldistrib, $idutilalmox){
        return $this->ped00100PedidosFactory->qtdeDisponivel($cdfilial, $cdproduto, $idctrldistrib, $idutilalmox);
    }
    
    public function replicaPedido($pedido, $prxPedido, $cdoperador){
        return $this->ped00100PedidosFactory->replicaPedido($pedido, $prxPedido, $cdoperador);
    }
    
    public function qtdeDispEstqReserva($reserva){
        return $this->ped00100PedidosFactory->qtdeDispEstqReserva($reserva);
    }
    
    public function recalculaVrPed($cdfilial, $nrpedido){
        return $this->ped00100PedidosFactory->recalculaVrPed($cdfilial, $nrpedido);
    }
    
    public function validaPedidoImportado($row){
        return $this->ped00100PedidosFactory->validaPedidoImportado($row);
    }
    
    public function validaClientPed($row){
        return $this->ped00100PedidosFactory->validaClientPed($row);
    }
    
    public function validaModalidadePagamento($row){
        return $this->ped00100PedidosFactory->validaModalidadePagamento($row);
    }
    
    public function validaModalidadePagamentoPadrao($row){
        return $this->ped00100PedidosFactory->validaModalidadePagamentoPadrao($row);
    }
    
    public function validaModalidadePagamentoCadastrada($row){
        return $this->ped00100PedidosFactory->validaModalidadePagamentoCadastrada($row);
    }

    
    public function validaVendedor($row){
        return $this->ped00100PedidosFactory->validaVendedor($row);
    }
    
    public function validaTabelaPrecoPrincipal($row){
        return $this->ped00100PedidosFactory->validaTabelaPrecoPrincipal($row);
    }
    
    public function validaTabelaPrecoSecundaria($row){
        return $this->ped00100PedidosFactory->validaTabelaPrecoSecundaria($row);
    }
    
    public function validaTabelaPrecoVendedor($row){
        return $this->ped00100PedidosFactory->validaTabelaPrecoVendedor($row);
    }
    
    public function validaTabelaPrecoPreCadastrada($row){
        return $this->ped00100PedidosFactory->validaTabelaPrecoPreCadastrada($row);
    }
    
    public function validaItem($row){
        return $this->ped00100PedidosFactory->validaItem($row);
    }
    
    public function validaArvItem($row){
        return $this->ped00100PedidosFactory->validaArvItem($row);
    }
    
    public function buscaPrecoPed($Pedido, $item){
        return $this->ped00100PedidosFactory->buscaPrecoPed($Pedido, $item);
    }
    
    public function insereTabelaPedido( $Pedido){
        $this->ped00100PedidosFactory->insereTabelaPedido($Pedido);
    }
    
    public function getDadosEntrega($cliente, $tipoEnd){
        return $this->ped00100PedidosFactory->getDadosEntrega($cliente, $tipoEnd);
    }
    
    public function insertDadosEntr($endEntrega, $pedido){
        
         $this->ped00100PedidosFactory->insertDadosEntr($endEntrega, $pedido);
    }
    
    public function getIdorigdestop($cdtipooper, $identrsaidop){
        return $this->ped00100PedidosFactory->getIdorigdestop($cdtipooper, $identrsaidop);
    }
    
    public function insereItenspedido($item, $pedido){
        $this->ped00100PedidosFactory->insereItenspedido($item, $pedido);
    }
    
    public function getPrazo($row){
        return $this->ped00100PedidosFactory->getPrazo($row);
    }
    
    public function inserePrazo( $pedido, $prazo){
         $this->ped00100PedidosFactory->inserePrazo($pedido, $prazo);
    }
    
    public function geraContaPrevista($cdfilial, $nrpedido, $idoperacao){
         $this->ped00100PedidosFactory->geraContaPrevista($cdfilial, $nrpedido, $idoperacao);
    }

    
}