CREATE OR REPLACE TRIGGER BLOQUEIO_CUSTO_MEDIO
BEFORE UPDATE OR INSERT OR DELETE ON LANCTOESTOQ
FOR EACH ROW
DECLARE
   V_COUNT NUMBER;
   V_USUARIO VARCHAR2(40);
   V_TIPO VARCHAR2(1);
   V_ITPESQ VARCHAR2(40);
   V_DESC VARCHAR2(300);
   V_DTOPER DATE;
   V_DSREMOTEADDR VARCHAR2(15);
   V_DSREMOTEHOST VARCHAR2(15);
   V_DSSERVERRDM  VARCHAR2(20);
   V_DSSERVMETHOD VARCHAR2(30);
   V_DSREMOTEOPER VARCHAR2(12);
   V_DSCHAVELOG VARCHAR2(30);
   V_NRCHAVELOG NUMBER;
   V_CDFILIAL VARCHAR2(04);
BEGIN
   V_COUNT := 0;
   IF INSERTING OR UPDATING THEN
      BEGIN
         SELECT COUNT(DTBLOQUEIO)
           INTO V_COUNT
           FROM CONTESTCUSTMED
          WHERE DTBLOQUEIO IS NOT NULL
            AND DTBLOQUEIO > :NEW.DTLANCESTQ
            AND CDFILIAL = :NEW.CDFILIMOVI;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      V_CDFILIAL := :NEW.CDFILIMOVI;
   END IF;

   IF DELETING THEN
      BEGIN
         SELECT COUNT(DTBLOQUEIO)
           INTO V_COUNT
           FROM CONTESTCUSTMED
          WHERE DTBLOQUEIO IS NOT NULL
            AND DTBLOQUEIO > :OLD.DTLANCESTQ
            AND CDFILIAL = :OLD.CDFILIMOVI;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_COUNT := 0;
      END;
      V_CDFILIAL := :OLD.CDFILIMOVI;
   END IF;

   IF V_COUNT <> 0 THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      NOVO_CODIGO_NT('LOGBLOQCUSTMED', V_DSCHAVELOG);
      V_NRCHAVELOG := TO_NUMBER(V_DSCHAVELOG);

      INS_LOG_CUSTO_MEDIO(V_NRCHAVELOG, SYSDATE, V_CDFILIAL, V_USUARIO, V_DSSERVERRDM,
                          V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);

      RAISE_APPLICATION_ERROR(-20501, 'OPERAO BLOQUEADA! A OPERAO IRIA MOVIMENTAR ESTOQUE PARA UMA '||
                                      'FILIAL COM O CUSTO MDIO J FECHADO! FAVOR CONSULTAR A CONTABILIDADE.', TRUE);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BLOQUEIO_CUSTO_MEDIO','5.45.xxx'); END;
/